#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "strext.h"
#include "list.h"
#include <libxml/xmlreader.h>

#define FALSE 0
#define TRUE 1

/*Variables globales*/
ListaLista urls;//list of special features as gradients fills, blur distortions, etc
// for now only support linear gradients but improve it is very easy
int bcanvas; 	//flag for write nodeCanvas anyway
char pname[256];//nama master Document
float a_width;	//width canvas
float a_height;	//height canvas
float ox;		//center canvas
float oy;		//center canvas
float kx=60; 	//kte default viewport

/*Declaracion de funciones*/
void nodeStartBasicLayer(xmlTextWriterPtr writer);
void nodeCloseBasicLayer(xmlTextWriterPtr writer);
void nodeWriteUrl(xmlTextWriterPtr writer,char* url);
void nodeUpdateUrl(ListaLista a);
void nodeWriteLinearGradient(xmlTextWriterPtr writer,LinearGradient* lg);
void nodeScanLinearGradient(xmlTextReaderPtr reader);
void nodeDefs(xmlTextReaderPtr reader);
void nodeParamf(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type,float value);
void nodeRotate(xmlTextWriterPtr writer,float dx,float dy,float angle);
void nodeTranslate(xmlTextWriterPtr writer,float dx,float dy);
void nodeTransform(xmlChar* transform,Matrix* dst);
void processDebug(xmlTextWriterPtr writer,xmlChar* path_d);
void dibujarCuadrado(xmlTextWriterPtr writer,float x,float y,float size);
void convert2Point(char *s,float *x, float *y);
void coor2vect(float *x, float *y);
void nodeRGBA(xmlTextWriterPtr writer,int ir, int ig, int ib,float fa);
void nodeRGBi(xmlTextWriterPtr writer,int r,int g,int b);
void nodeRGBf(xmlTextWriterPtr writer,float r, float g, float b);
void nodeNotParam(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type, xmlChar* value);
void nodeNotParamFloat(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type,float value,int precision);
void nodeParam(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type, xmlChar* value);
void nodeParam2V(xmlTextWriterPtr writer,xmlChar* name, xmlChar* value1,xmlChar* value2);
void nodeParam2Vgui(xmlTextWriterPtr writer,xmlChar* name, xmlChar* value1,xmlChar* value2,char *vectorgui);
void nodeParam2Vf(xmlTextWriterPtr writer,xmlChar* name,float value1,float value2);
void nodeSVG(xmlTextReaderPtr reader,xmlTextWriterPtr writer);
void nodeCanvas(xmlTextReaderPtr reader,xmlTextWriterPtr writer);
void nodeLayer(xmlTextReaderPtr reader,xmlTextWriterPtr writer,Matrix MasterMatrix);
void nodePath(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style,Matrix masterMatrix);
void nodePolygon(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style);
void nodeBline(xmlTextWriterPtr writer,Lista p,int loop,char* blinegui);
void nodeVectorList(xmlTextWriterPtr writer,Lista cab);
void nodeCircle(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style);
void nodeRect(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style);
void saltoLinea(xmlTextWriterPtr writer);
void DisplayAttributes(xmlTextReaderPtr reader);
static void processNode(xmlTextReaderPtr reader,xmlTextWriterPtr writer);
static void streamFile(const char *filename_input,const char *filename_output);

#ifdef LIBXML_READER_ENABLED

int main(int argc, char **argv) {
	
	LIBXML_TEST_VERSION	
	
	char ruta_input[100];
	char ruta_output[100];
	sprintf(ruta_input,"data/%s",argv[1]);
	if(argv[2]==NULL){
		sprintf(ruta_output,"data/");
		int olen=strlen (argv[1]);
		int i=0;
		for(i;i<olen-4;i++){
			sprintf(ruta_output,"%s%c",ruta_output,argv[1][i]);
		}
		sprintf(ruta_output,"%s%s",ruta_output,".sif");
	}else{
		sprintf(ruta_output,"data/%s",argv[2]);
	}
	printf("input : %s\n",ruta_input);
	printf("output: %s\n",ruta_output);
	streamFile(ruta_input,ruta_output);		
	
    xmlCleanupParser();
    xmlMemoryDump();	
    return(0);
}

#else
int main(void) {
    fprintf(stderr, "XInclude support not compiled in\n");
    exit(1);
}
#endif

void saltoLinea(xmlTextWriterPtr writer){
	xmlTextWriterWriteFormatRaw(writer,"\n");
}

void nodeParam2Vgui(xmlTextWriterPtr writer,xmlChar* name, xmlChar* value1,xmlChar* value2,char* vectorgui){
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",name);
	
	xmlTextWriterStartElement(writer,BAD_CAST "vector");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "guid",BAD_CAST vectorgui);
	
	xmlTextWriterWriteElement(writer,BAD_CAST "x",value1);
	//xmlTextWriterEndElement(writer);
	xmlTextWriterWriteElement(writer,BAD_CAST "y",value2);
	//xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);
	xmlTextWriterEndElement(writer);
}
void nodeParam(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type, xmlChar* value){
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",name);
	
	xmlTextWriterStartElement(writer, type);
	xmlTextWriterWriteAttribute(writer,BAD_CAST "value",value);
	xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);
}
void nodeNotParam(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type, xmlChar* value){
	xmlTextWriterStartElement(writer, BAD_CAST name);	
	
	xmlTextWriterStartElement(writer, type);
	xmlTextWriterWriteAttribute(writer,BAD_CAST "value",value);
	xmlTextWriterEndElement(writer);	
	
	xmlTextWriterEndElement(writer);
}
void nodeNotParamFloat(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type,float value,int precision){
	char valuefloat[15];
	if(precision==10) sprintf(valuefloat,"%.10f",value);
	else sprintf(valuefloat,"%.6f",value);
	xmlTextWriterStartElement(writer, BAD_CAST name);	
	
	xmlTextWriterStartElement(writer, type);
	xmlTextWriterWriteAttribute(writer,BAD_CAST "value",valuefloat);
	xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);
}
void nodeParam2V(xmlTextWriterPtr writer,xmlChar* name, xmlChar* value1,xmlChar* value2){
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",name);
	
	xmlTextWriterStartElement(writer,BAD_CAST "vector");	
	xmlTextWriterWriteElement(writer,BAD_CAST "x",value1);	
	xmlTextWriterWriteElement(writer,BAD_CAST "y",value2);	
	
	xmlTextWriterEndElement(writer);	
	xmlTextWriterEndElement(writer);
}
void nodeParam2Vf(xmlTextWriterPtr writer,xmlChar* name,float value1,float value2){
	
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",name);
	
	xmlTextWriterStartElement(writer,BAD_CAST "vector");
	
	xmlTextWriterWriteFormatElement(writer,BAD_CAST "x","%.10f",value1);
	//xmlTextWriterEndElement(writer);
	xmlTextWriterWriteFormatElement(writer,BAD_CAST "y","%.10f",value2);
	//xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);	
	xmlTextWriterEndElement(writer);
}

void nodeSVG(xmlTextReaderPtr reader,xmlTextWriterPtr writer){
	int i,top;
	top=xmlTextReaderAttributeCount(reader);	
	i=0;
	xmlChar* cname;
	xmlChar* cwidth;
	xmlChar* cheight;
	char dsada[10];
	a_height=a_width=0;
	bcanvas=0;
    while(i<top){
		xmlTextReaderMoveToAttributeNo(reader,i);
		
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"docname")==0){			
			cname=xmlStrsub(xmlTextReaderValue(reader),0,xmlStrlen(xmlTextReaderValue(reader))-4);								
			sprintf(pname,"%s",cname);
		}
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"width")==0){			
			getPixel(xmlTextReaderValue(reader),&a_width);
		}		
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"height")==0){			
			getPixel(xmlTextReaderValue(reader),&a_height);
		}
		i++;
	}
    xmlTextReaderMoveToElement(reader); //Moves the reader back to the element node.	
}

void nodeCanvas(xmlTextReaderPtr reader,xmlTextWriterPtr writer){
	int i,top;
	xmlChar* cwidth;
	xmlChar* cheight;
	xmlChar* canvas;
	canvas=xmlTextReaderName(reader);
	if(xmlStrcmp(canvas,BAD_CAST"namedview")==0){
		top=xmlTextReaderAttributeCount(reader);
		i=0;
		while(i<top){
			xmlTextReaderMoveToAttributeNo(reader,i);
			if(a_width==0 && xmlStrcmp(xmlTextReaderName(reader),(xmlChar *)"width")==0){				
				getPixel(xmlTextReaderValue(reader),&a_width);				
			}else{
				if(a_height==0 && xmlStrcmp(xmlTextReaderName(reader),(xmlChar *)"height")==0){					
					getPixel(xmlTextReaderValue(reader),&a_height);					
				}
			}
			i++;
		}
	}
	
	/*escritura*/
	xmlTextWriterStartElement(writer, BAD_CAST "canvas");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version",BAD_CAST "0.5");	
	if((a_width!=0 && a_height==0)||(a_width==0 && a_height!=0)){		
		if(a_width!=0){
			xmlTextWriterWriteFormatAttribute(writer, BAD_CAST "width",BAD_CAST "%f",a_width);
			xmlTextWriterWriteFormatAttribute(writer, BAD_CAST "height",BAD_CAST "%f",a_width);
			a_height=a_width;
		}else{		
			xmlTextWriterWriteFormatAttribute(writer, BAD_CAST "height",BAD_CAST "%f",a_height);
			xmlTextWriterWriteFormatAttribute(writer, BAD_CAST "width",BAD_CAST "%f",a_height);
			a_width=a_height;
		}
	}else{
		if(a_width!=0){
			xmlTextWriterWriteFormatAttribute(writer, BAD_CAST "width",BAD_CAST "%f",a_width);
		}else{
			xmlTextWriterWriteAttribute(writer, BAD_CAST "width",(xmlChar *)"768");
			a_width=768.0;
		}
		if(a_height!=0){
			xmlTextWriterWriteFormatAttribute(writer, BAD_CAST "height",BAD_CAST "%f",a_height);
		}else{
			xmlTextWriterWriteAttribute(writer, BAD_CAST "height",(xmlChar *)"1024");
			a_height=1024.0;
		}
	}
	
	xmlTextWriterWriteAttribute(writer, BAD_CAST "xres",BAD_CAST "2834.645752");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "yres",BAD_CAST "2834.645752");
	float view_x;
	float view_y;
	view_x=a_width/kx;
	view_y=a_height/kx;
	view_x=view_x/2.0;
	view_y=view_y/2.0;
	char attr_view_box[40];
	sprintf(attr_view_box,"%f %f %f %f",-1.0*view_x,view_y,view_x,-1.0*view_y);	
	xmlTextWriterWriteAttribute(writer, BAD_CAST "view-box",BAD_CAST attr_view_box);		
	ox=a_width/2;
	oy=a_height/2;		
	xmlTextWriterWriteAttribute(writer, BAD_CAST "antialias",BAD_CAST "1");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "fps",BAD_CAST "24.000");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "begin-time",BAD_CAST "0f");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "end-time",BAD_CAST "5s");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "bgcolor",BAD_CAST "0.500000 0.500000 0.500000 1.000000");				
	
	xmlTextWriterWriteElement(writer,BAD_CAST"name","Animation Synfig");
	
	xmlTextReaderMoveToElement(reader);
	
	
	bcanvas=1;
	nodeUpdateUrl(urls);
}

void nodeLayer(xmlTextReaderPtr reader,xmlTextWriterPtr writer,Matrix masterMatrix){
	
	int i,top,ret;
	top=xmlTextReaderAttributeCount(reader);
	i=0;
	xmlChar* label=NULL;
	xmlChar* id=NULL;
	xmlChar* style=NULL;
	
	xmlChar* transform=NULL;
	Matrix mtx=NULL;
	
	const xmlChar* name;
	name = BAD_CAST "--";
	//lectura de atributos
	while(i<top){
		xmlTextReaderMoveToAttributeNo(reader,i);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"label")==0)
			label=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"id")==0)
			id=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"style")==0)
			style=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"fill")==0){			
			char style2[128];
			sprintf(style2,"%s:%s",xmlTextReaderLocalName(reader),xmlTextReaderValue(reader));
			style=BAD_CAST style2;
		}// para demas casos como este se deberia "añadir" al mismo style
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"transform")==0){
			transform=xmlTextReaderValue(reader);			
		}
		i++;
	}
	//loading matrix3x3
	if(transform){
		nodeTransform(transform,&mtx);
	}
	if(masterMatrix){
		if(mtx)
			multiplyMatrix(&mtx,masterMatrix);
		else
			mtx=masterMatrix;
	}
	
	/*escritura*/
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","PasteCanvas");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.1");
	if(label)
		xmlTextWriterWriteAttribute(writer, BAD_CAST "desc",label);	
	else
		xmlTextWriterWriteAttribute(writer, BAD_CAST "desc","Unknow Layer");	
		
	nodeParam(writer,"z_depth","real","0.0000000000");
	nodeParam(writer,"amount","real","1.0000000000");
	nodeParam(writer,"blend_method","integer","0");
	nodeParam2V(writer,"origin","0.0000000000","0.0000000000");
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "name","canvas");
	xmlTextWriterStartElement(writer, BAD_CAST "canvas");
	
	//conversion de shapes del layer
	ret = xmlTextReaderRead(reader);
    while (ret == 1){
		name=xmlTextReaderConstName(reader);		
		if(xmlStrcmp(name,(xmlChar *)"rect")==0  && xmlTextReaderNodeType(reader)==1  ){
			nodeRect(reader,writer,style);
		}
		if(xmlStrcmp(name,(xmlChar *)"circle")==0  && xmlTextReaderNodeType(reader)==1  ){
			nodeCircle(reader,writer,style);
		}
		if(xmlStrcmp(name,(xmlChar *)"path")==0  && xmlTextReaderNodeType(reader)==1  ){						
			nodePath(reader,writer,style,mtx);
		}
		if(xmlStrcmp(name,(xmlChar *)"polygon")==0  && xmlTextReaderNodeType(reader)==1  ){			
			nodePolygon(reader,writer,style);
		}
		if(xmlStrcmp(name,(xmlChar *)"g")==0  && xmlTextReaderNodeType(reader)==15  ){
			break;
		}
		if(xmlStrcmp(name,(xmlChar *)"g")==0  && xmlTextReaderNodeType(reader)==1  ){
			nodeLayer(reader,writer,mtx);
		}
		ret = xmlTextReaderRead(reader);
	}
	
		
	xmlTextWriterEndElement(writer);//close canvas
	xmlTextWriterEndElement(writer);//close param canvas
	
	//cierro el layer
	if(ret==1){
		xmlTextWriterEndElement(writer); //cierro layer				
		saltoLinea (writer);
	}
		
	xmlTextReaderMoveToElement(reader);
}
void nodePath(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style,Matrix masterMatrix){
	
	int i,top;
	top=xmlTextReaderAttributeCount(reader);
	i=0;
	xmlChar* path_id=NULL;
	xmlChar* path_style=NULL;
	xmlChar* path_d=NULL;
	xmlChar* path_transform=NULL;
	//lectura de atributos
	while(i<top){
		xmlTextReaderMoveToAttributeNo(reader,i);
		//debo aumentar fill solito
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"style")==0)
			path_style=xmlTextReaderValue(reader);
		else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"id")==0)
			path_id=xmlTextReaderValue(reader);
		else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"d")==0)
			path_d=xmlTextReaderValue(reader);
		else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"transform")==0){
			path_transform=xmlTextReaderValue(reader);
		}else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"fill")==0){
			char style2[128];
			sprintf(style2,"%s:%s",xmlTextReaderLocalName(reader),xmlTextReaderValue(reader));
			path_style=BAD_CAST style2;
		}
		i++;
	}
	Matrix mtx=NULL;
	//loading matrix3x3
	if(path_transform){
		nodeTransform(path_transform,&mtx);
	}
	if(masterMatrix){
		if(mtx)
			multiplyMatrix(&mtx,masterMatrix);
		else
			mtx=masterMatrix;
	}	
	
	/*loading style*/
	
	char fill[40];
	char fill_rule[20];
	char stroke[40];
	char stroke_width[20];
	char stroke_linecap[20];
	char stroke_linejoin[20];
	char stroke_opacity[20];
	char fill_opacity[20];
	char opacity[20];
		
	loadAttribute(path_style,master_style,"fill",fill,"none");	
	loadAttribute(path_style,master_style,"fill-rule",fill_rule,"evenodd");
	loadAttribute(path_style,master_style,"stroke",stroke,"none");
	loadAttribute(path_style,master_style,"stroke-width",stroke_width,"1px");
	loadAttribute(path_style,master_style,"stroke-linecap",stroke_linecap,"butt");
	loadAttribute(path_style,master_style,"stroke-linejoin",stroke_linejoin,"miter");
	loadAttribute(path_style,master_style,"stroke-opacity",stroke_opacity,"1");
	loadAttribute(path_style,master_style,"fill-opacity",fill_opacity,"1");
	loadAttribute(path_style,master_style,"opacity",opacity,"1");
	
	if(!path_id){
		path_id=BAD_CAST "Curva";
	}
	if(!path_d){
		printf("El archivo svg contiene errores\n");
		exit(0);
	}
	/*analisis del path d*/
	char item[40];
	char auxp[40];
	char auxtg1[40];
	char auxtg2[40];
	float ax,ay;
	ListaLista ll=NULL;
	Lista cab_bline=NULL;
	Lista col_bline=NULL;
	strLowerCase(path_d);
	ax=ay=0;
	int loop=0;
	i=1;
	sprintf(item,"");
	
	while(strcmp(item,"NULL")!=0){
		getNextItemPath(path_d,item,i);
		if(strcmp(item,"m")==0){
			i++;
			cab_bline=NULL;
			getNextItemPath(path_d,auxp,i);
			convert2Point(auxp,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			Insertar(&cab_bline,&col_bline,nuevoTD(ax,ay));
			setSplit(col_bline,TRUE);
			
			ll=node_add(ll,cab_bline);
		}
		if(strcmp(item,"c")==0){
			i++;
			getNextItemPath(path_d,auxtg2,i);
			
			i++;
			getNextItemPath(path_d,auxtg1,i);
			
			i++;
			getNextItemPath(path_d,auxp,i);
			
			convert2Point(auxtg2,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			setTg2(col_bline,col_bline->Val.x,col_bline->Val.y,ax,ay);
			
			convert2Point(auxp,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			if(isFirst(cab_bline,ax,ay)){			
				convert2Point(auxtg1,&ax,&ay);
				if(mtx)
					transformPoint2D(mtx,&ax,&ay);
				coor2vect(&ax,&ay);
				setTg1(cab_bline,cab_bline->Val.x,cab_bline->Val.y,ax,ay);
			}else{
				Insertar(&cab_bline,&col_bline,nuevoTD(ax,ay));	
				convert2Point(auxtg1,&ax,&ay);
				if(mtx)
					transformPoint2D(mtx,&ax,&ay);
				coor2vect(&ax,&ay);
				setTg1(col_bline,col_bline->Val.x,col_bline->Val.y,ax,ay);
				setSplit(col_bline,TRUE);
			}
		}
		if(strcmp(item,"q")==0){
			i++;
			getNextItemPath(path_d,auxtg1,i);
			convert2Point(auxtg1,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			setTg1(col_bline,col_bline->Val.x,col_bline->Val.y,ax,ay);
			setSplit(col_bline,FALSE);
			i++;
			getNextItemPath(path_d,auxp,i);
			convert2Point(auxp,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			Insertar(&cab_bline,&col_bline,nuevoTD(ax,ay));
			convert2Point(auxtg1,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			setTg1(col_bline,col_bline->Val.x,col_bline->Val.y,ax,ay);
		}
		if(strcmp(item,"l")==0){
			i++;
			getNextItemPath(path_d,auxp,i);
			setTg2(col_bline,col_bline->Val.x,col_bline->Val.y,col_bline->Val.x,col_bline->Val.y);
			
			convert2Point(auxp,&ax,&ay);
			if(mtx)
				transformPoint2D(mtx,&ax,&ay);
			coor2vect(&ax,&ay);
			
			if(isFirst(cab_bline,ax,ay)){
				setTg1(cab_bline,cab_bline->Val.x,cab_bline->Val.y,cab_bline->Val.x,cab_bline->Val.y);
			}else{			
				Insertar(&cab_bline,&col_bline,nuevoTD(ax,ay));
				setTg1(col_bline,col_bline->Val.x,col_bline->Val.y,col_bline->Val.x,col_bline->Val.y);
			}
		}
		if(strcmp(item,"z")==0){
			loop=1;			
		}
		i++;
	}
	
	int typeFill=0; //nothing
	int typeStroke=0;//nothing
	//Fill	
	if(strcmp(fill,"none")!=0){
		typeFill=1; //simple
	}
	if(typeFill==1 && strncmp(fill,"url",3)==0){
		typeFill=2;	//gradient
	}
	//Stroke
	if(strcmp(stroke,"none")!=0){
		typeStroke=1; //simple
	}
	if(typeStroke==1 && strncmp(stroke,"url",3)==0){
		typeStroke=2;	//gradient
	}
	
	/*Escritura*/
	char bline_id[33];
	char offset_id[33];
	int n=countNodes(ll);
	//ImprimirListaLista (ll);	
	ListaLista aux;		
	
	aux=ll;	
	// si es diferente de uno se debera agrupar a todas regiones
	if(n!=1){
		nodeStartBasicLayer(writer);
	}
	//considerar loop dentro de la lista de listas
	for (; aux; aux = aux->next){
		sprintf(bline_id,"");
		sprintf(offset_id,"");
		if(typeFill!=0 && typeStroke!=0){
			generateGUID(bline_id);
			generateGUID(offset_id);
		}		
		if(n==1 && typeFill==2){
			nodeStartBasicLayer(writer);
		}		
		if(typeFill==1 || typeFill==2){
			//layer region
			saltoLinea (writer);
			xmlTextWriterStartElement(writer, BAD_CAST "layer");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "type","region");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.1");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "desc",path_id);		
			
			nodeParam(writer,BAD_CAST"z_depth",BAD_CAST"real",BAD_CAST"0.0000000000");
			nodeParam(writer,BAD_CAST"amount",BAD_CAST"real",BAD_CAST"1.0000000000");
			nodeParam(writer,BAD_CAST"blend_method",BAD_CAST"integer",BAD_CAST"0");
			//nodeRGBi(writer,getRed(fill),getGreen(fill),getBlue(fill));
			nodeRGBA(writer,getRed(fill),getGreen(fill),getBlue(fill),atof(fill_opacity)*atof(opacity));
			if(strcmp(offset_id,"")==0){
				nodeParam2V(writer,BAD_CAST"offset",BAD_CAST"0.0000000000",BAD_CAST"0.0000000000");		
			}else{
				nodeParam2Vgui(writer,BAD_CAST"offset",BAD_CAST"0.0000000000",BAD_CAST"0.0000000000",offset_id);
			}
			nodeParam(writer,BAD_CAST"invert",BAD_CAST"bool",BAD_CAST"false");
			nodeParam(writer,BAD_CAST"antialias",BAD_CAST"bool",BAD_CAST"true");
			//feather debe analizarse segun los filtros de path_style
			nodeParam(writer,BAD_CAST"feather",BAD_CAST"real",BAD_CAST"0.0000000000");
			nodeParam(writer,BAD_CAST"blurtype",BAD_CAST"integer",BAD_CAST"1");
			
			if(strcmp(fill_rule,"evenodd")==0) nodeParam(writer,BAD_CAST"winding_style",BAD_CAST"integer",BAD_CAST"1");
			else nodeParam(writer,BAD_CAST"winding_style",BAD_CAST"integer","0");
			
			//nodeBline(writer,(Lista)ll->data,loop,bline_id);
			nodeBline(writer,(Lista)aux->data,loop,bline_id);
			xmlTextWriterEndElement(writer);
		}
		/*gradientes in onto mode*/
		
		if(n==1 && typeFill==2){
			getUrlName(fill);
			nodeWriteUrl(writer,fill);
			nodeCloseBasicLayer(writer);
		}
		
		if(typeStroke==1 || typeStroke==2){
			//layer outline
			saltoLinea (writer);
			xmlTextWriterStartElement(writer, BAD_CAST "layer");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "type","outline");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.2");
			xmlTextWriterWriteAttribute(writer, BAD_CAST "desc",path_id);
			
			nodeParam(writer,BAD_CAST"z_depth",BAD_CAST"real",BAD_CAST"0.0000000000");
			nodeParam(writer,BAD_CAST"amount",BAD_CAST"real",BAD_CAST"1.0000000000");
			nodeParam(writer,BAD_CAST"blend_method",BAD_CAST"integer",BAD_CAST"0");
			//nodeRGBi(writer,getRed(stroke),getGreen(stroke),getBlue(stroke));
			nodeRGBA(writer,getRed(stroke),getGreen(stroke),getBlue(stroke),atof(stroke_opacity)*atof(opacity));
			if(strcmp(offset_id,"")==0){
				nodeParam2V(writer,BAD_CAST"offset",BAD_CAST"0.0000000000",BAD_CAST"0.0000000000");
			}else{
				nodeParam2Vgui(writer,BAD_CAST"offset",BAD_CAST"0.0000000000",BAD_CAST"0.0000000000",offset_id);
			}
			nodeParam(writer,BAD_CAST"invert",BAD_CAST"bool",BAD_CAST"false");
			nodeParam(writer,BAD_CAST"antialias",BAD_CAST"bool",BAD_CAST"true");
			//feather debe analizarse segun los filtros de path_style
			nodeParam(writer,BAD_CAST"feather",BAD_CAST"real",BAD_CAST"0.0000000000");
			nodeParam(writer,BAD_CAST"blurtype",BAD_CAST"integer",BAD_CAST"1");
			if(strcmp(fill_rule,"evenodd")==0) nodeParam(writer,BAD_CAST"winding_style",BAD_CAST"integer",BAD_CAST"1");
			else nodeParam(writer,BAD_CAST"winding_style",BAD_CAST"integer","0");
			
			nodeBline(writer,(Lista)aux->data,loop,bline_id);
			
			float stroke_width2=1.0/kx;
			sprintf(stroke_width,"%.10f",stroke_width2);
			nodeParam(writer,BAD_CAST"width",BAD_CAST"real",stroke_width);
			nodeParam(writer,BAD_CAST"expand",BAD_CAST"real",BAD_CAST"0.0000000000");
			if(strcmp(stroke_linejoin,"miter")==0) nodeParam(writer,BAD_CAST"sharp_cusps",BAD_CAST"bool",BAD_CAST"true");
			else nodeParam(writer,BAD_CAST"sharp_cusps",BAD_CAST"bool",BAD_CAST"false");
			if(strcmp(stroke_linecap,"butt")==0){
				nodeParam(writer,BAD_CAST"round_tip[0]",BAD_CAST"bool",BAD_CAST"false");
				nodeParam(writer,BAD_CAST"round_tip[1]",BAD_CAST"bool",BAD_CAST"false");
			}else{
				nodeParam(writer,BAD_CAST"round_tip[0]",BAD_CAST"bool",BAD_CAST"true");
				nodeParam(writer,BAD_CAST"round_tip[1]",BAD_CAST"bool",BAD_CAST"true");
			}
			nodeParam(writer,BAD_CAST"loopyness",BAD_CAST"real",BAD_CAST"1.0000000000");
			nodeParam(writer,BAD_CAST"homogeneous_width",BAD_CAST"bool",BAD_CAST"true");
			
			xmlTextWriterEndElement(writer);
		}
	}
	if(n!=1){
		nodeCloseBasicLayer(writer);
	}
}

void nodeBline(xmlTextWriterPtr writer,Lista p,int loop,char *blinegui){	
	
	xmlTextWriterStartElement(writer, BAD_CAST "param");	
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",BAD_CAST "bline");	
	xmlTextWriterStartElement(writer, BAD_CAST "bline");	
	xmlTextWriterWriteAttribute(writer,BAD_CAST "type",BAD_CAST "bline_point");	
	if(loop){ 
		xmlTextWriterWriteAttribute(writer,BAD_CAST "loop",BAD_CAST "true");		
	}else{
		xmlTextWriterWriteAttribute(writer,BAD_CAST "loop",BAD_CAST "false");
	}	
	if(strcmp(blinegui,"")!=0){
		xmlTextWriterWriteAttribute(writer,BAD_CAST "guid",BAD_CAST blinegui);		
	}	
	Lista aux=p;
	while(aux!=NULL){
		//entry
		xmlTextWriterStartElement(writer, BAD_CAST "entry");		
		xmlTextWriterStartElement(writer, BAD_CAST "composite");
		xmlTextWriterWriteAttribute(writer,BAD_CAST "type",BAD_CAST "bline_point");
					
			nodeParam2Vf(writer,BAD_CAST"point",aux->Val.x,aux->Val.y);
			nodeNotParam(writer,BAD_CAST "width",BAD_CAST "real",BAD_CAST "1.0000000000");
			nodeNotParam(writer,BAD_CAST "origin",BAD_CAST "real",BAD_CAST "0.5000000000");
			if(aux->Val.split) nodeNotParam(writer,BAD_CAST "split",BAD_CAST "bool",BAD_CAST "true");
			else nodeNotParam(writer,BAD_CAST "split",BAD_CAST "bool",BAD_CAST "false");
		
			//tangente 1
			xmlTextWriterStartElement(writer, BAD_CAST "t1");			
			xmlTextWriterStartElement(writer, BAD_CAST "radial_composite");			
			xmlTextWriterWriteAttribute(writer,BAD_CAST "type",BAD_CAST "vector");			
		
			nodeNotParamFloat(writer,BAD_CAST"radius",BAD_CAST"real",aux->Val.radio1,10);
			nodeNotParamFloat(writer,BAD_CAST"theta",BAD_CAST"angle",aux->Val.angle1,6);
			
			xmlTextWriterEndElement(writer);
			xmlTextWriterEndElement(writer);
					
			//tangente 2
			xmlTextWriterStartElement(writer, BAD_CAST "t2");			
			xmlTextWriterStartElement(writer, BAD_CAST "radial_composite");			
			xmlTextWriterWriteAttribute(writer,BAD_CAST "type",BAD_CAST "vector");		
			
			nodeNotParamFloat(writer,BAD_CAST"radius",BAD_CAST"real",aux->Val.radio2,10);
			nodeNotParamFloat(writer,BAD_CAST"theta",BAD_CAST"angle",aux->Val.angle2,6);		
			
			xmlTextWriterEndElement(writer);			
			xmlTextWriterEndElement(writer);			
					
		xmlTextWriterEndElement(writer);		
		xmlTextWriterEndElement(writer);
		
		aux=aux->sig;
	}	
	xmlTextWriterEndElement(writer);	
	xmlTextWriterEndElement(writer);	
}
void nodeCircle(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style){
	
	/*the circles in svg are paths with 'a' commands*/	
		
}
void nodePolygon(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style){	
	
	int i,top;
	top=xmlTextReaderAttributeCount(reader);
	i=0;
	xmlChar* poly_id=NULL;
	xmlChar* poly_points=NULL;
	xmlChar* poly_style=NULL;
	//lectura de atributos
	while(i<top){
		xmlTextReaderMoveToAttributeNo(reader,i);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"style")==0)
			poly_style=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"fill")==0){			
			char style2[128];
			sprintf(style2,"%s:%s",xmlTextReaderLocalName(reader),xmlTextReaderValue(reader));
			poly_style=BAD_CAST style2;
		}
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"id")==0)
			poly_id=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"points")==0)
			poly_points=xmlTextReaderValue(reader);
		i++;
	}
	
	char fill[40];
	char fill_rule[40];
	char fill_opacity[40];
	char opacity[40];
	loadAttribute(poly_style,master_style,"fill",fill,"none");
	loadAttribute(poly_style,master_style,"fill-rule",fill_rule,"evenodd");
	loadAttribute(poly_style,master_style,"fill-opacity",fill_opacity,"1");
	loadAttribute(poly_style,master_style,"opacity",opacity,"1");
	
	Lista a=NULL;
	Lista b=NULL;
	float ax,ay;
	ax=ay=0;
	char item[10];
	i=1;
	getNextItemPath(poly_points,item,i);
	while(strcmp(item,"NULL")!=0){	
		convert2Point(item,&ax,&ay);
		coor2vect(&ax,&ay);		
		Insertar(&a,&b,nuevoTD(ax,ay));
		i++;
		getNextItemPath(poly_points,item,i);
	}
	/*escritura*/
		
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","polygon");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.1");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "desc",poly_id);	
		nodeParam(writer,BAD_CAST"z_depth",BAD_CAST"real",BAD_CAST"0.0000000000");
		nodeParam(writer,BAD_CAST"amount",BAD_CAST"real",BAD_CAST"1.0000000000");
		nodeParam(writer,BAD_CAST"blend_method",BAD_CAST"integer",BAD_CAST"0");
		nodeRGBA(writer,getRed(fill),getGreen(fill),getBlue(fill),atof(fill_opacity)*atof(opacity));
		nodeParam2V(writer,BAD_CAST"offset",BAD_CAST"0.0000000000",BAD_CAST"0.0000000000");
		nodeParam(writer,BAD_CAST"invert",BAD_CAST"bool",BAD_CAST"false");
		nodeParam(writer,BAD_CAST"antialias",BAD_CAST"bool",BAD_CAST"true");
		nodeParam(writer,BAD_CAST"feather",BAD_CAST"real",BAD_CAST"0.0000000000");
		nodeParam(writer,BAD_CAST"blurtype",BAD_CAST"integer",BAD_CAST"1");
		if(strcmp(fill_rule,"evenodd")==0) nodeParam(writer,BAD_CAST"winding_style",BAD_CAST"integer",BAD_CAST"1");
		else nodeParam(writer,BAD_CAST"winding_style",BAD_CAST"integer","0");
		nodeVectorList(writer,a);
	xmlTextWriterEndElement(writer);
}
void nodeVectorList(xmlTextWriterPtr writer,Lista cab){
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",BAD_CAST "vector_list");
	xmlTextWriterStartElement(writer, BAD_CAST "dynamic_list");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "type",BAD_CAST "vector");
		
	Lista aux=cab;
	while(aux!=NULL){	
		xmlTextWriterStartElement(writer, BAD_CAST "entry");		
		
		xmlTextWriterStartElement(writer,BAD_CAST "vector");	
		xmlTextWriterWriteFormatElement(writer,BAD_CAST "x","%.10f",aux->Val.x);
		xmlTextWriterWriteFormatElement(writer,BAD_CAST "y","%.10f",aux->Val.y);
		xmlTextWriterEndElement(writer);		
		
		xmlTextWriterEndElement(writer);		
		aux=aux->sig;
	}	
	xmlTextWriterEndElement(writer);
	xmlTextWriterEndElement(writer);	
}
void nodeRect(xmlTextReaderPtr reader,xmlTextWriterPtr writer,char* master_style){
	int i,top;
	top=xmlTextReaderAttributeCount(reader);
	i=0;
	xmlChar* rect_x;
	xmlChar* rect_y;
	xmlChar* rect_width;
	xmlChar* rect_height;
	xmlChar* rect_id;
	xmlChar* rect_style;
	//lectura de atributos
	while(i<top){
		xmlTextReaderMoveToAttributeNo(reader,i);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"style")==0)
			rect_style=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"id")==0)
			rect_id=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"x")==0)
			rect_x=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"y")==0)
			rect_y=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"width")==0)
			rect_width=xmlTextReaderValue(reader);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"height")==0)
			rect_height=xmlTextReaderValue(reader);
		i++;
	}		
	
	char fill[40];	
	char fill_opacity[20];
	char opacity[20];
		
	loadAttribute(rect_style,master_style,"fill",fill,"none");	
	loadAttribute(rect_style,master_style,"fill-opacity",fill_opacity,"1");
	loadAttribute(rect_style,master_style,"opacity",opacity,"1");
		
	/*escritura*/
	xmlTextWriterStartElement(writer, BAD_CAST "layer");	
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","rectangle");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.2");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "desc",rect_id);
	
	nodeParam(writer,"z_depth","real","0.0000000000");
	nodeParam(writer,"amount","real","1.0000000000");
	nodeParam(writer,"blend_method","integer","0");
	
	//nodeRGBi(writer,getRed(value),getGreen(value),getBlue(value));	
	nodeRGBA (writer,getRed (fill),getGreen (fill),getBlue(fill),atof(opacity)*atof(fill_opacity));
	
	float auxx;
	float auxy;
	auxx=atof(rect_x);
	auxy=atof(rect_y);
	coor2vect(&auxx,&auxy);
	nodeParam2Vf(writer,BAD_CAST"point1",auxx,auxy);
	auxx= atof(rect_x) + atof(rect_width);
	auxy= atof(rect_y) + atof(rect_height);	
	coor2vect(&auxx,&auxy);
	nodeParam2Vf(writer,BAD_CAST"point2",auxx,auxy);
	
	
	nodeParam(writer,BAD_CAST"expand",BAD_CAST"real",BAD_CAST"0.0000000000");
	nodeParam(writer,BAD_CAST"invert",BAD_CAST"bool",BAD_CAST"false");
	
	xmlTextWriterEndElement(writer);	
	return;	
}

void DisplayAttributes(xmlTextReaderPtr reader){
	int i,top;
	top=xmlTextReaderAttributeCount(reader);
	if (xmlTextReaderHasAttributes(reader)){         
		 i=0;
         while(i<top){		
			xmlTextReaderMoveToAttributeNo(reader,i);
			printf("\tatributo n%d - %s - %s\n",i,xmlTextReaderName(reader),xmlTextReaderValue(reader));
			i++;
         }		
         xmlTextReaderMoveToElement	(reader); //Moves the reader back to the element node.
      }
}

static void processNode(xmlTextReaderPtr reader,xmlTextWriterPtr writer) {
    const xmlChar *name, *value;
	int ret;
    name = xmlTextReaderConstName(reader);
    if (name == NULL)
		name = BAD_CAST "--";
    value = xmlTextReaderConstValue(reader);
	/*
	printf("%d %s %d #d\n",
		   	xmlTextReaderDepth(reader),
		   	xmlTextReaderName(reader),
			xmlTextReaderNodeType(reader),
		   	xmlTextReaderHasValue(reader)
		   );
	
	DisplayAttributes(reader);
	
	*/
	if(xmlStrncmp(name,BAD_CAST "svg",3)==0  && xmlTextReaderNodeType(reader)==1 ){
		nodeSVG(reader,writer);
	}
	if(xmlStrcmp(name,(xmlChar*)"namedview")==0){
		nodeCanvas(reader,writer);
	}
	if(xmlStrncmp(name,BAD_CAST "defs",3)==0  && xmlTextReaderNodeType(reader)==1 ){				
		nodeDefs(reader);		
	}
	if(xmlStrncmp(name,(xmlChar *)"svg",3)==0  && xmlTextReaderNodeType(reader)==15  ){		
		xmlTextWriterEndElement(writer);
	}
	/*layers*/
	if(  xmlStrcmp(name,(xmlChar *)"g")==0   &&   xmlTextReaderNodeType(reader)==1){
		if(!bcanvas)
			nodeCanvas(reader,writer);
		nodeLayer(reader,writer,NULL);
	}
	if(xmlStrcmp(name,(xmlChar *)"path")==0   &&   xmlTextReaderNodeType(reader)==1){
		if(!bcanvas)
			nodeCanvas(reader,writer);
		nodePath(reader,writer,NULL,NULL);
	}
	if(xmlStrcmp(name,(xmlChar *)"polygon")==0   &&   xmlTextReaderNodeType(reader)==1){
		if(!bcanvas)
			nodeCanvas(reader,writer);
		nodePolygon(reader,writer,NULL);
	}
}

static void streamFile(const char *filename_input,const char *filename_output) {
	int ret;
    xmlTextReaderPtr reader;	
	int rc;
    xmlTextWriterPtr writer;
    xmlChar *tmp;
    writer = xmlNewTextWriterFilename(filename_output, 0);
	if (writer == NULL){
        printf("testXmlwriterFilename: Error creating the xml writer\n");
        return;
    }
	rc = xmlTextWriterStartDocument(writer, NULL, MY_ENCODING, NULL);
    if (rc < 0) {
        printf("testXmlwriterFilename: Error at xmlTextWriterStartDocument\n");
        return;
    }
	
    reader = xmlReaderForFile(filename_input, NULL, 0);
    if (reader != NULL) {
        ret = xmlTextReaderRead(reader);
        while (ret == 1) {
            processNode(reader,writer);
            ret = xmlTextReaderRead(reader);			
        }
        xmlFreeTextReader(reader);
        if (ret != 0) {
            fprintf(stderr, "%s : failed to parse\n", filename_input);
        }
    }else{
        fprintf(stderr, "Unable to open %s\n", filename_input);
    }
	rc = xmlTextWriterEndDocument(writer);
    if (rc < 0){
        printf("testXmlwriterFilename: Error at xmlTextWriterEndDocument\n"); return;
    }
    xmlFreeTextWriter(writer);
}

void nodeRGBf(xmlTextWriterPtr writer,float r, float g, float b){
	xmlTextWriterStartElement(writer, BAD_CAST "color");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",BAD_CAST "color");
	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "r","%f",r);
	xmlTextWriterEndElement(writer);
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "g","%f",g);
	xmlTextWriterEndElement(writer);
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "b","%f",b);
	xmlTextWriterEndElement(writer);
	xmlTextWriterWriteElement(writer, BAD_CAST "a",BAD_CAST "1.000000");
	xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);
	xmlTextWriterEndElement(writer);
}
void nodeRGBi(xmlTextWriterPtr writer,int ir, int ig, int ib){
	double r,g,b;
	r=((float)ir)/255.0;
	g=((float)ig)/255.0;
	b=((float)ib)/255.0;
	
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",BAD_CAST "color");
	
	xmlTextWriterStartElement(writer, BAD_CAST "color");
	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "r","%f",r);	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "g","%f",g);	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "b","%f",b);	
	xmlTextWriterWriteElement(writer, BAD_CAST "a",BAD_CAST "1.000000");
		
	xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);
}
void nodeRGBA(xmlTextWriterPtr writer,int ir, int ig, int ib,float fa){
	double r,g,b;	
	r=((float)ir*100.0)/255.0;
	g=((float)ig*100.0)/255.0;
	b=((float)ib*100.0)/255.0;	
	r=r/100.0;
	g=g/100.0;
	b=b/100.0;
	//this need gamma adjustment	
	
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",BAD_CAST "color");
	
	xmlTextWriterStartElement(writer, BAD_CAST "color");
	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "r","%f",r);	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "g","%f",g);	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "b","%f",b);	
	xmlTextWriterWriteFormatElement(writer, BAD_CAST "a","%f",fa);
		
	xmlTextWriterEndElement(writer);
	
	xmlTextWriterEndElement(writer);
}

void coor2vect(float *x,float *y){
	float sx, sy;
	sx=*x;
	sy=*y;
	/*reflejar*/
	sy= a_height-sy;
	/*vectorizar*/
	sx= sx - ox;
	sy= sy - oy;
	/*encajar*/
	sx= sx / kx;
	sy= sy / kx;
	*x=sx; *y=sy;
}
void convert2Point(char *s,float *x, float *y){
	char aux[40];
	sprintf(aux,"%s",s);
	int length=strlen(s);
	int medio=strchar(s,",")-1;
	char ax[20];
	char ay[20];
	cortar(s,ax,0,medio);
	cortar(s,ay,medio+1,length);
	*x=atof(ax);
	*y=atof(ay);
	
	return;
}
void dibujarCuadrado(xmlTextWriterPtr writer,float x,float y,float size){
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","rectangle");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.2");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "desc","debug");
	
	nodeParam(writer,"z_depth","real","0.0000000000");
	nodeParam(writer,"amount","real","1.0000000000");
	nodeParam(writer,"blend_method","integer","0");
	nodeRGBi(writer,255,0,255);	
	nodeParam2Vf(writer,BAD_CAST"point1",x,y);	
	nodeParam2Vf(writer,BAD_CAST"point2",x+size,y+size);
		
	nodeParam(writer,BAD_CAST"expand",BAD_CAST"real",BAD_CAST"0.0000000000");
	nodeParam(writer,BAD_CAST"invert",BAD_CAST"bool",BAD_CAST"false");
	
	xmlTextWriterEndElement(writer);
	return;	
}
void processDebug(xmlTextWriterPtr writer,xmlChar* path_d){	
	int i;
	char item[40];
	sprintf(item,"");
	printf("\n\n");
	i=1;
	printf("Debug Mode\n");
	while(strcmp(item,"NULL")!=0){
		getNextItemPath(path_d,item,i);
		printf("item[%d] es '%s'\n",i,item);
		i++;
	}
	printf("\n\n");
}

void nodeTransform(xmlChar* transform,Matrix* dst){
	char tf[128];
	Matrix a=NULL;
	sprintf(tf,"%s",transform);
	if(strncmp(tf,"translate",9)==0){		
		float dx,dy;
		dx=dy=0;
		char cdx[10];
		char cdy[10];
		cortar(tf,cdx,strchar(transform,"("),strchar(transform,",")-1);
		cortar(tf,cdy,strchar(transform,","),strlen(transform)-1);
		dx=atof(cdx);
		dy=atof(cdy);
		if(matrixVacia(a))
			a=newMatrixf(1,0,0,1,dx,dy);
		else
			multiplyMatrix(&a,newMatrixf(1,0,0,1,dx,dy));
			
	}else if(xmlStrncmp(transform,(xmlChar*)"scale",5)==0){
		
		
	}else if(xmlStrncmp(transform,(xmlChar*)"rotate",6)==0){
		/*
		float amount;
		char cda[30];
		if(strchar(tf,",")==strrchar(tf,",")){
			cortar(tf,cda,strchar(transform,"("),strlen(transform)-1);
			amount=atof(cda);
			nodeRotate(writer,0,0,amount);
		}else{
			printf("angulo necesita punto de pivote\n");
		}
		*/
	}else if(xmlStrncmp(transform,(xmlChar*)"matrix",6)==0){
		char cda[128];
		cortar(tf,cda,strchar(transform,"("),strlen(transform)-1);
		if(matrixVacia(a))
			a=newMatrixs(cda);
		else
			multiplyMatrix(&a,newMatrixs(cda));
		
	}else{
		a=newMatrixf(1,0,0,1,0,0);
	}	
	*dst=a;	
}

void nodeTranslate(xmlTextWriterPtr writer,float dx,float dy){
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","translate");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.1");	
	nodeParam2Vf(writer,"origin",dx,dy);
	xmlTextWriterEndElement(writer);
}
void nodeRotate(xmlTextWriterPtr writer,float dx,float dy,float angle){
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","rotate");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.1");
	nodeParam2Vf(writer,"origin",dx,dy);
	nodeParamf(writer,"amount","angle",angle);
	xmlTextWriterEndElement(writer);
}
void nodeParamf(xmlTextWriterPtr writer,xmlChar* name,xmlChar* type,float value){
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer,BAD_CAST "name",name);
	
	xmlTextWriterStartElement(writer, type);
	xmlTextWriterWriteFormatAttribute(writer,BAD_CAST "value","%f",value);
	xmlTextWriterEndElement(writer);	
	
	xmlTextWriterEndElement(writer);
}
void nodeDefs(xmlTextReaderPtr reader){
	int depth=xmlTextReaderDepth(reader);	
	urls=NULL;
	int ret,top;
	const xmlChar* name;
	
	ret=top=0;
	ret = xmlTextReaderRead(reader);
	if(depth==xmlTextReaderDepth(reader)){
		return; //dont exists definitions
	}
    while (ret == 1){
		name=xmlTextReaderConstName(reader);
		if(xmlStrcmp(name,(xmlChar *)"defs")==0  && xmlTextReaderNodeType(reader)==15){						
			return;
		}else if(xmlStrcmp(name,(xmlChar *)"linearGradient")==0  && xmlTextReaderNodeType(reader)==1  ){
			nodeScanLinearGradient(reader);
		}
		ret = xmlTextReaderRead(reader);
	}	
}
void nodeScanLinearGradient(xmlTextReaderPtr reader){	
	int i,top,ret;
	i=0;
	top=xmlTextReaderAttributeCount(reader);
	
	const xmlChar* name;
	name = BAD_CAST "--";
	int depth=xmlTextReaderDepth(reader);
	
	Node* stops=NULL;
	float x1,y1,x2,y2;
	x1=y1=x2=y2=0;
	xmlChar* link=NULL;
	char id[64];
	
	while(i<top){
		xmlTextReaderMoveToAttributeNo(reader,i);
		if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"id")==0){
			sprintf(id,"#%s",xmlTextReaderValue(reader));
		}else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"x1")==0){			
			x1=atof(xmlTextReaderValue(reader));
		}else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"y1")==0){
			y1=atof(xmlTextReaderValue(reader));
		}else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"x2")==0){
			x2=atof(xmlTextReaderValue(reader));
		}else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"y2")==0){
			y2=atof(xmlTextReaderValue(reader));
		}else if(xmlStrcmp(xmlTextReaderName(reader),(xmlChar *)"xlink:href")==0){
			link=xmlTextReaderValue(reader);
		}
		i++;
	}
	if(link){
		printf("buscando %s\n",link);
		stops=getStopsUrls(urls,link);
	}
	ret=xmlTextReaderRead(reader);
	int depth2=xmlTextReaderDepth(reader);
	
	if(depth2>depth && !link){
		while(ret==1){
			name=xmlTextReaderConstName(reader);			
			if(xmlStrcmp(name,(xmlChar *)"linearGradient")==0 && xmlTextReaderNodeType(reader)==15 ){				
				break;			
			}else if(xmlStrcmp(name,(xmlChar *)"stop")==0){
				top=xmlTextReaderAttributeCount(reader);
				i=0;
				xmlChar* style=NULL;
				float offset=0.0;				
				while(i<top){
					xmlTextReaderMoveToAttributeNo(reader,i);
					if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"style")==0){						
						style=xmlTextReaderValue(reader);
					}else if(xmlStrcmp(xmlTextReaderLocalName(reader),(xmlChar *)"offset")==0){
						offset=atof(xmlTextReaderValue(reader));
					}
					i++;
				}
				char stop_color[40];
				char opacity[40];
				if(style){
					extractSubAttribute(style,"stop-color",stop_color);					
					extractSubAttribute(style,"stop-opacity",opacity);
				}
				stops=node_add(stops,nuevoStop(stop_color,atof(opacity),offset));
			}
			ret=xmlTextReaderRead(reader);
		}
	}
	/*Set in memory*/
	urls=node_add(urls,nuevoUrl(0,nuevoLinearGradient(id,x1,y1,x2,y2,stops)));
	//esta lista necesita ser actualizada en Node_Canvas
}
void nodeUpdateUrl(ListaLista a){
	ListaLista aux;
	Url* aux2;
	aux=a;
	while(aux!=NULL){
		aux2=(Url*)aux->data;
		if(aux2->type==0){
			LinearGradient* aux3=(LinearGradient*)aux2->data;
			if(aux3->x1!=0 && aux3->x2!=0 && aux3->y1!=0 && aux3->y2!=0){
				coor2vect(&aux3->x1,&aux3->y1);
				coor2vect(&aux3->x2,&aux3->y2);
			}
		}
		aux=aux->next;
	}
	return;
}
void nodeWriteUrl(xmlTextWriterPtr writer,char* url){
	Url* layerUrl;
	layerUrl=getUrls(urls,url);
	if(layerUrl){
		if(layerUrl->type==0){
			nodeWriteLinearGradient(writer,(LinearGradient*)layerUrl->data);
		}
	}
}
void nodeWriteLinearGradient(xmlTextWriterPtr writer,LinearGradient* lg){
	
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","linear_gradient");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.0");	
	
		nodeParam(writer,BAD_CAST"z_depth",BAD_CAST"real",BAD_CAST"0.0000000000");
		nodeParam(writer,BAD_CAST"amount",BAD_CAST"real",BAD_CAST"1.0000000000");
		//onto blend
		nodeParam(writer,BAD_CAST"blend_method",BAD_CAST"integer",BAD_CAST"21");		
		nodeParam2Vf(writer,BAD_CAST"p1",lg->x1,lg->y1);
		nodeParam2Vf(writer,BAD_CAST"p2",lg->x2,lg->y2);
		//gradient
		Node* aux;
		Stop* aux2;
		aux=lg->stops;
		
		xmlTextWriterStartElement(writer, BAD_CAST "param");
		xmlTextWriterWriteAttribute(writer,BAD_CAST "name","gradient");
		xmlTextWriterStartElement(writer, BAD_CAST "gradient");
		while(aux!=NULL){
			aux2=(Stop*)aux->data;
			
			xmlTextWriterStartElement(writer, BAD_CAST "color");
			xmlTextWriterWriteFormatAttribute(writer,BAD_CAST "pos","%f",aux2->pos);
			
				xmlTextWriterWriteFormatElement(writer, BAD_CAST "r","%f",aux2->r);
				xmlTextWriterWriteFormatElement(writer, BAD_CAST "g","%f",aux2->g);
				xmlTextWriterWriteFormatElement(writer, BAD_CAST "b","%f",aux2->b);
				xmlTextWriterWriteFormatElement(writer, BAD_CAST "a","%f",aux2->a);
			
			xmlTextWriterEndElement(writer);
			
			aux=aux->next;
		}
		xmlTextWriterEndElement(writer);
		xmlTextWriterEndElement(writer);
		
		nodeParam(writer,BAD_CAST"loop",BAD_CAST"bool",BAD_CAST"false");
		nodeParam(writer,BAD_CAST"zigzag",BAD_CAST"bool",BAD_CAST"false");
		
	xmlTextWriterEndElement(writer);	
}
void nodeStartBasicLayer(xmlTextWriterPtr writer){
	xmlTextWriterStartElement(writer, BAD_CAST "layer");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "type","PasteCanvas");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "active","true");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "version","0.1");	
	xmlTextWriterWriteAttribute(writer, BAD_CAST "desc","Composite");
	nodeParam(writer,"z_depth","real","0.0000000000");
	nodeParam(writer,"amount","real","1.0000000000");
	nodeParam(writer,"blend_method","integer","0");
	nodeParam2V(writer,"origin","0.0000000000","0.0000000000");
	xmlTextWriterStartElement(writer, BAD_CAST "param");
	xmlTextWriterWriteAttribute(writer, BAD_CAST "name","canvas");
	xmlTextWriterStartElement(writer, BAD_CAST "canvas");
	
	//canvas
	return;
}
void nodeCloseBasicLayer(xmlTextWriterPtr writer){
	xmlTextWriterEndElement(writer);//close canvas
	xmlTextWriterEndElement(writer);//close param canvas
	xmlTextWriterEndElement(writer);//close g	
	return;
}
